# coding: utf-8

"""
    Collibra Import API

    <p>The Import API is an efficient way to load large volumes of data into the Collibra Data Governance Center. The API can automatically differentiate between creating and updating data.</p>  # noqa: E501

    The version of the OpenAPI document: 2.0
    Generated by: https://openapi-generator.tech
"""


import pprint
import re  # noqa: F401

import six

from collibra_importer.configuration import Configuration


class SynchronizationBatchCsvInJobRequest(object):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    """
    Attributes:
      openapi_types (dict): The key is attribute name
                            and the value is attribute type.
      attribute_map (dict): The key is attribute name
                            and the value is json key in definition.
    """
    openapi_types = {
        'send_notification': 'bool',
        'batch_size': 'int',
        'simulation': 'bool',
        'save_result': 'bool',
        'synchronization_id': 'str',
        'file_id': 'str',
        'file': 'file',
        'file_name': 'str',
        'delete_file': 'bool',
        'continue_on_error': 'bool',
        'separator': 'str',
        'quote': 'str',
        'escape': 'str',
        'strict_quotes': 'bool',
        'ignore_leading_whitespace': 'bool',
        'header_row': 'bool',
        'template': 'str'
    }

    attribute_map = {
        'send_notification': 'sendNotification',
        'batch_size': 'batchSize',
        'simulation': 'simulation',
        'save_result': 'saveResult',
        'synchronization_id': 'synchronizationId',
        'file_id': 'fileId',
        'file': 'file',
        'file_name': 'fileName',
        'delete_file': 'deleteFile',
        'continue_on_error': 'continueOnError',
        'separator': 'separator',
        'quote': 'quote',
        'escape': 'escape',
        'strict_quotes': 'strictQuotes',
        'ignore_leading_whitespace': 'ignoreLeadingWhitespace',
        'header_row': 'headerRow',
        'template': 'template'
    }

    def __init__(self, send_notification=None, batch_size=1000, simulation=None, save_result=None, synchronization_id=None, file_id=None, file=None, file_name=None, delete_file=None, continue_on_error=None, separator=None, quote=None, escape=None, strict_quotes=None, ignore_leading_whitespace=None, header_row=None, template=None, local_vars_configuration=None):  # noqa: E501
        """SynchronizationBatchCsvInJobRequest - a model defined in OpenAPI"""  # noqa: E501
        if local_vars_configuration is None:
            local_vars_configuration = Configuration()
        self.local_vars_configuration = local_vars_configuration

        self._send_notification = None
        self._batch_size = None
        self._simulation = None
        self._save_result = None
        self._synchronization_id = None
        self._file_id = None
        self._file = None
        self._file_name = None
        self._delete_file = None
        self._continue_on_error = None
        self._separator = None
        self._quote = None
        self._escape = None
        self._strict_quotes = None
        self._ignore_leading_whitespace = None
        self._header_row = None
        self._template = None
        self.discriminator = None

        if send_notification is not None:
            self.send_notification = send_notification
        if batch_size is not None:
            self.batch_size = batch_size
        if simulation is not None:
            self.simulation = simulation
        if save_result is not None:
            self.save_result = save_result
        self.synchronization_id = synchronization_id
        if file_id is not None:
            self.file_id = file_id
        if file is not None:
            self.file = file
        if file_name is not None:
            self.file_name = file_name
        if delete_file is not None:
            self.delete_file = delete_file
        if continue_on_error is not None:
            self.continue_on_error = continue_on_error
        self.separator = separator
        self.quote = quote
        self.escape = escape
        if strict_quotes is not None:
            self.strict_quotes = strict_quotes
        if ignore_leading_whitespace is not None:
            self.ignore_leading_whitespace = ignore_leading_whitespace
        if header_row is not None:
            self.header_row = header_row
        self.template = template

    @property
    def send_notification(self):
        """Gets the send_notification of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        Whether job status notification should be sent. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :return: The send_notification of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._send_notification

    @send_notification.setter
    def send_notification(self, send_notification):
        """Sets the send_notification of this SynchronizationBatchCsvInJobRequest.

        Whether job status notification should be sent. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :param send_notification: The send_notification of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: bool
        """

        self._send_notification = send_notification

    @property
    def batch_size(self):
        """Gets the batch_size of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        <i>The batchSize parameter is now deprecated and is ignored during command execution.</i>  # noqa: E501

        :return: The batch_size of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: int
        """
        return self._batch_size

    @batch_size.setter
    def batch_size(self, batch_size):
        """Sets the batch_size of this SynchronizationBatchCsvInJobRequest.

        <i>The batchSize parameter is now deprecated and is ignored during command execution.</i>  # noqa: E501

        :param batch_size: The batch_size of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: int
        """
        if (self.local_vars_configuration.client_side_validation and
                batch_size is not None and batch_size < 1):  # noqa: E501
            raise ValueError("Invalid value for `batch_size`, must be a value greater than or equal to `1`")  # noqa: E501

        self._batch_size = batch_size

    @property
    def simulation(self):
        """Gets the simulation of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        Whether the import should be triggered as a simulation. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the result of the import simulation will be available at the end of the job but no change will be applied to the DGC.  # noqa: E501

        :return: The simulation of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._simulation

    @simulation.setter
    def simulation(self, simulation):
        """Sets the simulation of this SynchronizationBatchCsvInJobRequest.

        Whether the import should be triggered as a simulation. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the result of the import simulation will be available at the end of the job but no change will be applied to the DGC.  # noqa: E501

        :param simulation: The simulation of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: bool
        """

        self._simulation = simulation

    @property
    def save_result(self):
        """Gets the save_result of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        Whether the import Result should be persisted or forgotten. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the result of the import simulation will be available at the end of the job but no change will be applied to the DGC.<p><b>DEPRECATED:</b>This parameter is deprecated and will be removed in the future.</b>.  # noqa: E501

        :return: The save_result of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._save_result

    @save_result.setter
    def save_result(self, save_result):
        """Sets the save_result of this SynchronizationBatchCsvInJobRequest.

        Whether the import Result should be persisted or forgotten. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the result of the import simulation will be available at the end of the job but no change will be applied to the DGC.<p><b>DEPRECATED:</b>This parameter is deprecated and will be removed in the future.</b>.  # noqa: E501

        :param save_result: The save_result of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: bool
        """

        self._save_result = save_result

    @property
    def synchronization_id(self):
        """Gets the synchronization_id of this SynchronizationBatchCsvInJobRequest.  # noqa: E501


        :return: The synchronization_id of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._synchronization_id

    @synchronization_id.setter
    def synchronization_id(self, synchronization_id):
        """Sets the synchronization_id of this SynchronizationBatchCsvInJobRequest.


        :param synchronization_id: The synchronization_id of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and synchronization_id is None:  # noqa: E501
            raise ValueError("Invalid value for `synchronization_id`, must not be `None`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                synchronization_id is not None and len(synchronization_id) > 50):
            raise ValueError("Invalid value for `synchronization_id`, length must be less than or equal to `50`")  # noqa: E501
        if (self.local_vars_configuration.client_side_validation and
                synchronization_id is not None and len(synchronization_id) < 1):
            raise ValueError("Invalid value for `synchronization_id`, length must be greater than or equal to `1`")  # noqa: E501

        self._synchronization_id = synchronization_id

    @property
    def file_id(self):
        """Gets the file_id of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        The <code>id</code> of uploaded file.<p><b>NOTE:</b> if this field is used, <code>file</code> should not be set.  # noqa: E501

        :return: The file_id of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._file_id

    @file_id.setter
    def file_id(self, file_id):
        """Sets the file_id of this SynchronizationBatchCsvInJobRequest.

        The <code>id</code> of uploaded file.<p><b>NOTE:</b> if this field is used, <code>file</code> should not be set.  # noqa: E501

        :param file_id: The file_id of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: str
        """

        self._file_id = file_id

    @property
    def file(self):
        """Gets the file of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        The file to upload. If set, then also <code>fileName</code> should be provided.<p><b>NOTE:</b> if this field is used, <code>fileId</code> should not be set.  # noqa: E501

        :return: The file of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: file
        """
        return self._file

    @file.setter
    def file(self, file):
        """Sets the file of this SynchronizationBatchCsvInJobRequest.

        The file to upload. If set, then also <code>fileName</code> should be provided.<p><b>NOTE:</b> if this field is used, <code>fileId</code> should not be set.  # noqa: E501

        :param file: The file of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: file
        """

        self._file = file

    @property
    def file_name(self):
        """Gets the file_name of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        The name of the file to upload. If set, then also <code>file</code> should be provided.<p><b>NOTE:</b> if this field is used, <code>fileId</code> should not be set.  # noqa: E501

        :return: The file_name of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._file_name

    @file_name.setter
    def file_name(self, file_name):
        """Sets the file_name of this SynchronizationBatchCsvInJobRequest.

        The name of the file to upload. If set, then also <code>file</code> should be provided.<p><b>NOTE:</b> if this field is used, <code>fileId</code> should not be set.  # noqa: E501

        :param file_name: The file_name of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: str
        """

        self._file_name = file_name

    @property
    def delete_file(self):
        """Gets the delete_file of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        Whether the file should be deleted after the synchronization job is finished, regardless of the result. <b>The default value</b> is <code>false</code>.<p><b>NOTE:</b> if the file corresponds to an attachment, the attachment will be deleted.  # noqa: E501

        :return: The delete_file of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._delete_file

    @delete_file.setter
    def delete_file(self, delete_file):
        """Sets the delete_file of this SynchronizationBatchCsvInJobRequest.

        Whether the file should be deleted after the synchronization job is finished, regardless of the result. <b>The default value</b> is <code>false</code>.<p><b>NOTE:</b> if the file corresponds to an attachment, the attachment will be deleted.  # noqa: E501

        :param delete_file: The delete_file of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: bool
        """

        self._delete_file = delete_file

    @property
    def continue_on_error(self):
        """Gets the continue_on_error of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        Whether the import should continue if some of the import commands are invalid or failed to execute. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the valid commands are still committed to the database, which can lead to partial results being stored.  # noqa: E501

        :return: The continue_on_error of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._continue_on_error

    @continue_on_error.setter
    def continue_on_error(self, continue_on_error):
        """Sets the continue_on_error of this SynchronizationBatchCsvInJobRequest.

        Whether the import should continue if some of the import commands are invalid or failed to execute. <b>The default value</b> is <code>false</code>.<p>If <code>true</code>, the valid commands are still committed to the database, which can lead to partial results being stored.  # noqa: E501

        :param continue_on_error: The continue_on_error of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: bool
        """

        self._continue_on_error = continue_on_error

    @property
    def separator(self):
        """Gets the separator of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        The delimiter character used to separate entries. <b>The default value</b> is <code>';'</code>.  # noqa: E501

        :return: The separator of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._separator

    @separator.setter
    def separator(self, separator):
        """Sets the separator of this SynchronizationBatchCsvInJobRequest.

        The delimiter character used to separate entries. <b>The default value</b> is <code>';'</code>.  # noqa: E501

        :param separator: The separator of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and separator is None:  # noqa: E501
            raise ValueError("Invalid value for `separator`, must not be `None`")  # noqa: E501

        self._separator = separator

    @property
    def quote(self):
        """Gets the quote of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        The delimiter character used for quoted entries. <b>The default value</b>  is <code>'\"'</code>.  # noqa: E501

        :return: The quote of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._quote

    @quote.setter
    def quote(self, quote):
        """Sets the quote of this SynchronizationBatchCsvInJobRequest.

        The delimiter character used for quoted entries. <b>The default value</b>  is <code>'\"'</code>.  # noqa: E501

        :param quote: The quote of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and quote is None:  # noqa: E501
            raise ValueError("Invalid value for `quote`, must not be `None`")  # noqa: E501

        self._quote = quote

    @property
    def escape(self):
        """Gets the escape of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        The delimiter character used to escape separator or quote character. <b>The default value</b> is <code>'\\\\'</code>.  # noqa: E501

        :return: The escape of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._escape

    @escape.setter
    def escape(self, escape):
        """Sets the escape of this SynchronizationBatchCsvInJobRequest.

        The delimiter character used to escape separator or quote character. <b>The default value</b> is <code>'\\\\'</code>.  # noqa: E501

        :param escape: The escape of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and escape is None:  # noqa: E501
            raise ValueError("Invalid value for `escape`, must not be `None`")  # noqa: E501

        self._escape = escape

    @property
    def strict_quotes(self):
        """Gets the strict_quotes of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        Whether the characters outside quotes should be ignored. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :return: The strict_quotes of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._strict_quotes

    @strict_quotes.setter
    def strict_quotes(self, strict_quotes):
        """Sets the strict_quotes of this SynchronizationBatchCsvInJobRequest.

        Whether the characters outside quotes should be ignored. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :param strict_quotes: The strict_quotes of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: bool
        """

        self._strict_quotes = strict_quotes

    @property
    def ignore_leading_whitespace(self):
        """Gets the ignore_leading_whitespace of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        Whether whitespace characters before quotes should be ignored. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :return: The ignore_leading_whitespace of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._ignore_leading_whitespace

    @ignore_leading_whitespace.setter
    def ignore_leading_whitespace(self, ignore_leading_whitespace):
        """Sets the ignore_leading_whitespace of this SynchronizationBatchCsvInJobRequest.

        Whether whitespace characters before quotes should be ignored. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :param ignore_leading_whitespace: The ignore_leading_whitespace of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: bool
        """

        self._ignore_leading_whitespace = ignore_leading_whitespace

    @property
    def header_row(self):
        """Gets the header_row of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        Whether the first row of the synchronized CSV file is the header. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :return: The header_row of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: bool
        """
        return self._header_row

    @header_row.setter
    def header_row(self, header_row):
        """Sets the header_row of this SynchronizationBatchCsvInJobRequest.

        Whether the first row of the synchronized CSV file is the header. <b>The default value</b> is <code>false</code>.  # noqa: E501

        :param header_row: The header_row of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: bool
        """

        self._header_row = header_row

    @property
    def template(self):
        """Gets the template of this SynchronizationBatchCsvInJobRequest.  # noqa: E501

        The template that should be used for parsing and synchronizing the contents of the CSV file.  <br/><p>There is one placeholder currently supported:<ul>     <li><b>${x}</b> - refers to the n-th column in the CSV file, e.g. ${1}, ${2}, ...)</li></ul><p>Example of a correct JSON template:</p> <pre> [   {     \"resourceType\": \"Asset\",     \"identifier\": {       \"name\": \"${1}\",       \"domain\": {         \"name\": \"${2}\",         \"community\": {           \"name\": \"Some Community\"         }       }     },     \"attributes\" : {       \"00000000-0000-0000-0000-000000003115\" : [ {         \"value\" : \"${3}\"        } ],       \"00000000-0000-0000-0000-000000000222\" : [ {         \"value\" : \"${4}\"       } ]     }   } ] </pre>  # noqa: E501

        :return: The template of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :rtype: str
        """
        return self._template

    @template.setter
    def template(self, template):
        """Sets the template of this SynchronizationBatchCsvInJobRequest.

        The template that should be used for parsing and synchronizing the contents of the CSV file.  <br/><p>There is one placeholder currently supported:<ul>     <li><b>${x}</b> - refers to the n-th column in the CSV file, e.g. ${1}, ${2}, ...)</li></ul><p>Example of a correct JSON template:</p> <pre> [   {     \"resourceType\": \"Asset\",     \"identifier\": {       \"name\": \"${1}\",       \"domain\": {         \"name\": \"${2}\",         \"community\": {           \"name\": \"Some Community\"         }       }     },     \"attributes\" : {       \"00000000-0000-0000-0000-000000003115\" : [ {         \"value\" : \"${3}\"        } ],       \"00000000-0000-0000-0000-000000000222\" : [ {         \"value\" : \"${4}\"       } ]     }   } ] </pre>  # noqa: E501

        :param template: The template of this SynchronizationBatchCsvInJobRequest.  # noqa: E501
        :type: str
        """
        if self.local_vars_configuration.client_side_validation and template is None:  # noqa: E501
            raise ValueError("Invalid value for `template`, must not be `None`")  # noqa: E501

        self._template = template

    def to_dict(self):
        """Returns the model properties as a dict"""
        result = {}

        for attr, _ in six.iteritems(self.openapi_types):
            value = getattr(self, attr)
            if isinstance(value, list):
                result[attr] = list(map(
                    lambda x: x.to_dict() if hasattr(x, "to_dict") else x,
                    value
                ))
            elif hasattr(value, "to_dict"):
                result[attr] = value.to_dict()
            elif isinstance(value, dict):
                result[attr] = dict(map(
                    lambda item: (item[0], item[1].to_dict())
                    if hasattr(item[1], "to_dict") else item,
                    value.items()
                ))
            else:
                result[attr] = value

        return result

    def to_str(self):
        """Returns the string representation of the model"""
        return pprint.pformat(self.to_dict())

    def __repr__(self):
        """For `print` and `pprint`"""
        return self.to_str()

    def __eq__(self, other):
        """Returns true if both objects are equal"""
        if not isinstance(other, SynchronizationBatchCsvInJobRequest):
            return False

        return self.to_dict() == other.to_dict()

    def __ne__(self, other):
        """Returns true if both objects are not equal"""
        if not isinstance(other, SynchronizationBatchCsvInJobRequest):
            return True

        return self.to_dict() != other.to_dict()
